#!/usr/bin/env python

import re
import sys
rooms = []
treasures = []
room = 0
size = 0
for line in sys.stdin:
	if(re.match('[a-f0-9]',line)):
		fields = re.split('\s',line)
		room = int(fields[0],16)
		try:
			(exit, cost) = re.split(',',fields[1])
		except:
			(exit, cost) = ("3e7", "3e7") 
		if(fields[1] == "**"):
			treasures.append(room - 1) # -1 for 0-index arrays
		room += 1
		exit = int(exit,16)
		exit -= 1 # Python uses 0-index arrays
		cost = int(cost,16)
		rooms.append((exit,cost))
		size += 1

def init_path(size):
	path = []
	for a in range(size):
		path.append(999)
	return path

def walk(path, start, cost, size, rooms, direction):
	room = start
	# Annoying that Python doesn't have do-while
	if(path[room] < cost):
		return 
	path[room] = cost
	(exit, ucost) = rooms[room]
	if(exit < 998):
		walk(path, exit, cost + ucost, size, rooms, direction)
		walk(path, exit, cost + ucost, size, rooms, -direction)
	room += direction
	room %= size
	cost += 1
	while(room != start):
		if(path[room] < cost):
			return 
		path[room] = cost
		(exit, ucost) = rooms[room]
		if(exit < 998):
			walk(path, exit, cost + ucost, size, rooms, direction)
			walk(path, exit, cost + ucost, size, rooms, -direction)
		room += direction
		room %= size
		cost += 1
	return

tpath = []
for treasure in treasures:
	path = init_path(size)
	walk(path,treasure,0,size,rooms,-1)
	walk(path,treasure,0,size,rooms,1)
	tpath.append(path)

def get_closest_treasure(tpath, start):
	low = 999
	element = 999
	index = 0
	place = 0
	for path in tpath:
		if(path != [] and path[start] < low):
			low = path[start]
			element = index
		index += 1
	index = 0
	for a in tpath[element]:
		if(a == 0):
			place = index
		index += 1
	tpath[element] = [] # We can only grab a treasure once
	return (low, place, element)

total_cost = 0
place = 0
torder = []
for a in range(len(tpath)):
	(cost, place, tnum) = get_closest_treasure(tpath, place)
	torder.append(tnum)
	total_cost += cost
print str(total_cost) + " " + str(torder)

